#!/bin/sh

VERSION="1.0.3" # VERSION_HANDLER

L="$@"


# Récupère l'action
ACTION=`echo $L | sed 's/sentinelle\:\/\///g' | sed 's/\/?/?/g' | cut -d\? -f1`
L=`echo $L | sed 's/sentinelle\:\/\///g'| sed 's/\%5E/^/g'| cut -d\? -f2`


# Parse les paramètres ============================
INDEX=1
while [ true ] ; do
	param=`echo $L | cut -d\& -f$INDEX`
	if [ "$param" = "" ] ; then break; fi
	INDEX=`expr $INDEX + 1`
  eval $param
  if [ "$param" = "$L" ] ; then break; fi
done
# ==================================================

DIR=`dirname $0` 

# Services
if [ "$ACTION" = "services" ] ; then
    if [ "$url"   = "" -o "$id" = "" ] ; then
        echo "URL de base ou identifiant non déclaré" 
        exit
    fi

    srvfile="$DIR/SWListener.jar"
    link=$url"handler/sentinelle-handler-linux/SWListener.jar"

    # Options par défaut du wget 
    options=" --no-check-certificate -O $srvfile "

    # Si le cleartust ct est positionné, on tente de passer le cookie CTSESSION au wget
    if [ "$ct" != "" ] ; then
        DOMAINE=`echo "$url" | cut -d/ -f3 | cut -d. -f2-3`
	echo ".$DOMAINE 	TRUE	/	FALSE	0	CTSESSION	$ct" > /tmp/cookies.txt
	options="$options --cookies=on --load-cookies /tmp/cookies.txt "
    fi

    # Lancement du wget        
    options=$options" $link"
    wget $options


    if [ ! -e "$srvfile" ] ; then
            echo "Impossible de récupérer le service SWListener"
            exit
    fi

    if [ -e /etc/alternatives/java ] ; then
        nohup /etc/alternatives/java -jar $srvfile  "$url" "$id" "$VERSION" "$ct"  &
    else
        nohup java  -jar $srvfile  "$url" "$id" "$VERSION" "$ct" &
    fi


fi

# Putty 
if [ "$ACTION" = "putty" ] ; then
	OPTIONS=""
	if [ $user   != "" ] ; then  OPTIONS="$OPTIONS -l $user";    fi
	if [ $passwd != "" ] ; then  OPTIONS="$OPTIONS -pw $passwd"; fi
	if [ $port   != "" ] ; then  OPTIONS="$OPTIONS -P $port";    fi	
	putty $host $OPTIONS

fi

# Ping
if [ "$ACTION" = "ping" ] ; then
	xterm -e ping $host
fi

# VNC
if [ "$ACTION" = "vnc" ] ; then
	vncviewer $host
fi

# TUNNEL
if [ "$ACTION" = "tunnel" ] ; then
	putty -L  $psrc:$toip:$pdest $host -l $user -pw $passwd
fi

# Bureau à Distance
if [ "$ACTION" = "rdesktop" ] ; then
	rdesktop $host
fi

# SCP via filezilla
if [ "$ACTION" = "winscp" ] ; then
	filezilla $user:$passwd@$host:$port
fi

