#!/bin/sh


DIR=$( (cd -P $(dirname $0) && pwd) )
path="$DIR/sentinelle-handler.sh"


if [ ! -e $path ] ; then
    echo "$path introuvable" 
    echo "L'installation doit être éxécutée dans le même dossier que sentinelle-handler.sh"
    exit
fi

detectDE()
{
    if [ x"$KDE_FULL_SESSION" = x"true" ]; then DE=kde;
    elif [ x"$GNOME_DESKTOP_SESSION_ID" != x"" ]; then DE=gnome;
    elif xprop -root _DT_SAVE_MODE | grep ' = \"xfce4\"$' >/dev/null 2>&1; then DE=xfce;
    fi
}

setkde()
{
    echo "Environement KDE"
    if [ ! -d ~/.kde/share/kde4/services ] ; then
	echo "Erreur ~/.kde/share/kde4/services inexistant"
	exit
    fi
    echo "
[Protocol]
exec=$path \"%u\"
protocol=sentinelle
input=none
output=none
helper=true
listing=false
reading=false
writing=false
makedir=false
deleting=false" > ~/.kde/share/kde4/services/sentinelle.protocol
   echo " OK"
}

setgnome()
{
    echo "Environnement Gnome"   
    gconftool-2  --type string --set /desktop/gnome/url-handlers/sentinelle/command 		"$path"
    gconftool-2  --type bool   --set /desktop/gnome/url-handlers/sentinelle/enabled 		true
    gconftool-2  --type bool   --set /desktop/gnome/url-handlers/sentinelle/needs_terminal 	false
    echo " OK"
}



dpkg -s libnotify-bin >/dev/null 2>&1
if [ $? -ne 0 ] ; then
    echo "libnotify-bin est nécessaire"
    sudo apt-get -f -y install libnotify-bin
fi

which java
if [ $? -ne 0 ] ; then
    echo "Java est nécessaire pour faire fonctionner le listener"
    echo "Pour l'installer entrer le commande suivante"
    echo "   apt-get install sun-java6-jre"
    exit
fi

detectDE

if [ x"$DE" = x"" ]; then
    DE=generic
fi


case "$DE" in
    kde)
    setkde
    ;;

    gnome)
    setgnome
    ;;

    xfce)
    nosupported
    ;;

    generic)
    nosupported
    ;;

    *)
    exit_failure_operation_impossible "no method available for opening '$url'"
    ;;
esac



